/**
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/.
 *
 * Copyright (C) 2013, 2014 Department of Informatics and
 * Telecommunications, National and Kapodistrian University of Athens
 *
 *      Author: Stella Giannakopoulou <sgian@di.uoa.gr>
 */

#ifndef ARR_CONSOLIDATED_FORMATTER_H
#define ARR_CONSOLIDATED_FORMATTER_H

#include <iostream>
#include <CGAL/Arrangement_2/Arrangement_on_surface_2_global.h>
#include <CGAL/Arr_consolidated_curve_data_traits_2.h>
#include <CGAL/IO/Arr_text_formatter.h>
#include <CGAL/IO/Arr_iostream.h>
#include <iterator>
#include <string>
using namespace std;

template <class Arrangement_>
class Arr_consolidated_curve_text_formatter : public CGAL::Arr_face_extended_text_formatter <Arrangement_>
{
public:	
	typedef Arrangement_                                   Arrangement_2;
	typedef typename Arrangement_2::Halfedge_const_handle  Halfedge_const_handle;
	typedef typename Arrangement_2::Halfedge_handle  Halfedge_handle;
	typedef string                                       Data;
	typedef CGAL::_Unique_list<string>                         Data_container;
	typedef Data_container::const_iterator     Data_const_iterator;
	
	void write_halfedge_data (Halfedge_const_handle he)
	{
		Data_const_iterator dit;
		this->out() << "\nEDGE DATA\n";
		for (dit = he->curve().data().begin(); dit != he->curve().data().end(); ++dit)
		{			
			 this->out() << *dit<<endl;
		}
		this->out()<<"END EDGE DATA";
	}
	
	void read_halfedge_data (Halfedge_handle he)
	{
		string data;
		
		getline(this->in(), data);		
		getline(this->in(), data);
		while(data != "END EDGE DATA")
		{
			he->curve().data().insert(data);
			getline(this->in(), data);
		}
	}
};

#endif
